; Pour la configuration de JDE  partir de:
; UPenn Fall '98 Emacs configuration for JDE
; Alexy V. Khrabrov (alex@suffix.com),
; Aaron Bloomfield (aaronb@gradient.cis.upenn.edu)
;
; pour les outils JDE et l'adaptation  l'env. DIRO
; UdM April 2001
; Mohamed Lokbani (lokbani@iro.umontreal.ca)
; Mise  jour avec versions plus rcentes April 2002
; Compilation de certains rpertoires lisp pour allger
; le chargement.

; ------------------------------------------------------------
; configuration de base pour JDE

; jde

(setq load-path (cons "C:/emacs-21.2/site-lisp/packages/jde-2.2.8" load-path)) 

; Uncomment this line if you want the JDE to be automatically
; loaded every time Emacs starts
(require 'jde)


; Set the backspace key (Ctrl-h) to delete backwards and
; help to be Ctrl-x?
(global-set-key "\C-h" 'delete-backward-char)
(global-set-key "\C-c\C-h" 'help-command) 
(global-set-key [f1] 'help-command)

; Useful shortcuts
(global-set-key "\M-g" 'goto-line)
(global-set-key "\M-n" 'switch-to-buffer)   ; was 'view-file
(global-set-key "\M-o" 'other-window)

; Default text features
(setq inhibit-startup-message t)
(setq next-line-add-newlines nil)
(setq require-final-newline t)
(setq-default truncate-lines nil)

; Auto-fill in text mode by default
(setq text-mode-hook (quote (lambda nil (auto-fill-mode 1))))
(setq-default fill-column 79)
(setq-default auto-fill-hook 'do-auto-fill)

; Default mode is text
(setq default-major-mode 'text-mode)
(text-mode)

; Time and mail flag
(display-time)

; Ispell
(autoload 'ispell-word "ispell" "Check spelling of word at or before point" t)
(autoload 'ispell-complete-word "ispell" "Complete word at or before point" t)
(autoload 'ispell-region "ispell" "Check spelling of every word in the region" t)
(autoload 'ispell-buffer "ispell" "Check spelling of every word in the buffer" t)

; Java mode
; -- Java Development Environment

;*** Java mode
;--- ---------
(add-hook 'java-mode-hook
	  '(lambda ()
	     (local-set-key "\C-c\C-c" 'jde-compile); was comment-region
	     (local-set-key "\C-c\C-r" 'jde-run)
	     (local-set-key "\C-c\C-z" 'comment-region)
	     (make-local-variable 'compile-command)
	     (setq compile-command
		   (concat "javac "	;; Sun Java compiler command
			   (cond (buffer-file-name
				  (file-name-nondirectory
				   buffer-file-name))
				 ((buffer-name)))))))



;; Lesha sets path straight first; when I recompile all, elc will contain
;; all of these and adding java-mode to load-path below can be encommented.

(setq load-path (cons (expand-file-name "C:/emacs-21.2/site-lisp/packages/jde-2.2.8") load-path))

(autoload ' jde-mode "jde.el" "java mode" t nil)
(autoload ' java-mode "jde.el" "java mode" t nil)
;; Do I need to load the rest or they can be autoloaded:
;; Lesha may disable an/or put java-mode in
;; hilit-mode-enable-list:
; (load "hilit-java.el") 
; (load "java-f-lck.el")
; (load "imenu.el")
; (load "jde-db.el")
; (load "jde-run.el")


;(set-default 'auto-mode-alist
;             (append '(
;                       ("\\.java" . java-mode) ; "\\.java\\'"
;                       ("\\.jj" . java-mode)
;                       ("\\.jjt" . java-mode)
;		       )
;                   (delete '("\\.pl\\'" . prolog-mode) auto-mode-alist)))
;
;; The above from Arnaud doesn't seem to work, 
;; so Lesha sticks with good old setq, and do jde-mode:

(setq auto-mode-alist (cons
      '("\\.java\\'" . jde-mode) auto-mode-alist))

; Can make "C-cC-c" compile, and "C-cC-b" run the program.
; To run, must give a class name.  The ".java" suffix can 
; be cut off as follows:

; (setq name "chavo.java")
; (string-match "\\(.*\\)\\.java" name)
; (setq name-base (substring name (match-beginning 1) (match-end 1)))


; JDE customization
; enable the javac -g debugging switch
(custom-set-variables
 '(jde-compile-option-debug (quote ("all" (t nil nil)))))
(custom-set-faces)


(provide 'jde-maconf)
; end of JDE config

